Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents btnAnswer As System.Windows.Forms.Button
    Friend WithEvents lblQuestion As System.Windows.Forms.Label
    Friend WithEvents txtAnswer As System.Windows.Forms.TextBox
    Friend WithEvents lblTryAgain As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnAnswer = New System.Windows.Forms.Button
        Me.lblQuestion = New System.Windows.Forms.Label
        Me.txtAnswer = New System.Windows.Forms.TextBox
        Me.lblTryAgain = New System.Windows.Forms.Label
        Me.SuspendLayout()
        '
        'btnAnswer
        '
        Me.btnAnswer.Font = New System.Drawing.Font("Arial", 20.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnAnswer.Location = New System.Drawing.Point(66, 216)
        Me.btnAnswer.Name = "btnAnswer"
        Me.btnAnswer.Size = New System.Drawing.Size(152, 48)
        Me.btnAnswer.TabIndex = 0
        Me.btnAnswer.Text = "Start"
        '
        'lblQuestion
        '
        Me.lblQuestion.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblQuestion.Font = New System.Drawing.Font("Arial", 50.0!)
        Me.lblQuestion.Location = New System.Drawing.Point(10, 32)
        Me.lblQuestion.Name = "lblQuestion"
        Me.lblQuestion.Size = New System.Drawing.Size(272, 80)
        Me.lblQuestion.TabIndex = 1
        Me.lblQuestion.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'txtAnswer
        '
        Me.txtAnswer.Font = New System.Drawing.Font("Arial", 50.0!)
        Me.txtAnswer.Location = New System.Drawing.Point(10, 120)
        Me.txtAnswer.Name = "txtAnswer"
        Me.txtAnswer.Size = New System.Drawing.Size(272, 84)
        Me.txtAnswer.TabIndex = 2
        Me.txtAnswer.Text = ""
        Me.txtAnswer.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        '
        'lblTryAgain
        '
        Me.lblTryAgain.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblTryAgain.ForeColor = System.Drawing.Color.FromArgb(CType(0, Byte), CType(0, Byte), CType(192, Byte))
        Me.lblTryAgain.Location = New System.Drawing.Point(10, 8)
        Me.lblTryAgain.Name = "lblTryAgain"
        Me.lblTryAgain.Size = New System.Drawing.Size(272, 24)
        Me.lblTryAgain.TabIndex = 3
        Me.lblTryAgain.Text = "Try again!"
        Me.lblTryAgain.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        Me.lblTryAgain.Visible = False
        '
        'Form1
        '
        Me.AcceptButton = Me.btnAnswer
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 270)
        Me.Controls.Add(Me.lblTryAgain)
        Me.Controls.Add(Me.txtAnswer)
        Me.Controls.Add(Me.lblQuestion)
        Me.Controls.Add(Me.btnAnswer)
        Me.Name = "Form1"
        Me.Text = "MathCards"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Const NUM_QUESTIONS As Integer = 10
    Private Const MIN_NUMBER As Integer = 0
    Private Const MAX_NUMBER As Integer = 10
    Private Const MAX_GUESSES As Integer = 2
    Private m_QuestionNumber As Integer = 0
    Private m_NumRight As Integer
    Private m_NumWrong As Integer
    Private m_NumGuesses As Integer
    Private m_Answer As Integer
    Private m_Rand As Random

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        m_Rand = New Random
    End Sub

    Private Sub btnAnswer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAnswer.Click
        If m_QuestionNumber < 1 Then
            btnAnswer.Text = "Answer"
            m_QuestionNumber = 1
            m_NumRight = 0
            m_NumWrong = 0
            ShowQuestion()
        Else
            CheckAnswer()
        End If
    End Sub

    ' Display a new question.
    ' This version picks from two operators: + and -.
    Private Sub ShowQuestion()
        Dim num1 As Integer = m_Rand.Next(MIN_NUMBER, MAX_NUMBER + 1)
        Dim num2 As Integer = m_Rand.Next(MIN_NUMBER, MAX_NUMBER + 1)

        ' Pick the operator.
        Dim op As String = ""
        Const NUM_OPERATORS As Integer = 2
        Select Case m_Rand.Next(0, NUM_OPERATORS)
            Case 0 ' +
                op = "+"
                m_Answer = num1 + num2
            Case 1 ' -
                op = "-"
                If num1 < num2 Then
                    Dim temp As Integer = num1
                    num1 = num2
                    num2 = temp
                End If
                m_Answer = num1 - num2
        End Select

        lblQuestion.Text = _
            num1.ToString() & " " & op & " " & _
            num2.ToString()
        m_NumGuesses = 0
        lblTryAgain.Visible = False

        Me.Text = "MathCards " & _
            m_QuestionNumber.ToString() & _
            " of " & NUM_QUESTIONS.ToString()

        txtAnswer.Text = ""
        txtAnswer.Focus()
    End Sub

    ' Check the user's answer.
    Private Sub CheckAnswer()
        Dim guess As Integer = Val(txtAnswer.Text)
        txtAnswer.Text = ""
        txtAnswer.Focus()

        If Math.Abs(guess - m_Answer) < 0.01 Then
            ' Right. Show another question.
            m_NumRight += 1
            m_QuestionNumber += 1
            If m_QuestionNumber > NUM_QUESTIONS Then
                ' We're done.
                lblQuestion.Text = ""
                txtAnswer.Text = ""
                Dim results As String = _
                    "Results:" & vbCrLf & _
                    "    Right: " & m_NumRight & vbCrLf & _
                    "    Wrong: " & m_NumWrong & vbCrLf & _
                    "  % Right: " & _
                    FormatPercent(m_NumRight / (m_NumRight + m_NumWrong))
                MessageBox.Show(results, "Good Job!")

                btnAnswer.Text = "Start"
                Me.Text = "MathCards"
            Else
                ' Show another question.
                ShowQuestion()
            End If
        Else
            ' Wrong. Give the user another chance.
            m_NumWrong += 1
            m_NumGuesses += 1
            If m_NumGuesses > MAX_GUESSES Then
                ' Show a new question.
                ShowQuestion()
            Else
                ' Let the user try again.
                lblTryAgain.Visible = True
                Beep()
            End If
        End If
    End Sub
End Class
